<template>
  <div class="application-graphs">
    <q-page padding v-if="!$route.meta.isChild">
      <h6>Application Graphs</h6>
      <q-btn label="Create New HDAG" color="primary" @click="showDialog = true" />
      <div v-if="isLoading">Loading...</div>
      <div v-if="error">{{ error }}</div>
      <div v-else class="q-gutter-md" style="display: flex; flex-wrap: wrap">
        <div class="q-pa-md" v-for="(artifact, name) in artifacts" :key="name" style="width: 300px">
          <q-card>
            <q-card-section>
              <div class="card-header">
                <div class="text-h6">{{ artifact.descriptorId }}</div>
                <div class="card-header-actions">
                  <q-btn padding="2px 5px" size="10px" flat icon="edit"
                    @click="() => showDescriptor(artifact.descriptor?.id)" aria-label="Edit Descriptor">
                    <q-tooltip>Edit Descriptor</q-tooltip>
                  </q-btn>
                  <q-btn padding="2px 5px" size="10px" flat icon="hub" @click="viewGraph(artifact.descriptor?.id)"
                    aria-label="View Graph">
                    <q-tooltip>View Graph</q-tooltip>
                  </q-btn>
                  <q-btn padding="2px 5px" size="10px" flat icon="settings" @click="() => editIntent(artifact)"
                    aria-label="Edit Intent">
                    <q-tooltip>Edit Intent</q-tooltip>
                  </q-btn>
                </div>
              </div>
              <div><strong>Type:</strong> {{ artifact.artifactType }}</div>
              <div><strong>Name:</strong> {{ artifact.descriptor?.name }}</div>
              <div><strong>ID:</strong> {{ artifact.descriptor?.id }}</div>
              <div>
                <strong>Version:</strong> {{ artifact.descriptor.version }}
              </div>
              <div class="q-mt-md">
                <strong>Dependencies:</strong>
                <ul>
                  <li v-for="dependency in artifact.dependencies" :key="dependency.ref">
                    {{
                      dependency.ref.split('/')[
                      dependency.ref.split('/').length - 1
                      ]
                    }}
                    ({{ dependency.artifactType }})
                  </li>
                </ul>
              </div>
            </q-card-section>
            <q-card-section>
              <q-btn @click="publishDescriptor">Start </q-btn>
            </q-card-section>
          </q-card>
        </div>
      </div>
      <q-dialog v-model="showDialog">
        <q-card style="width: 800px; max-width: 800px">
          <q-card-section>
            <div class="text-h6">Create New HDAG</div>
          </q-card-section>
          <q-card-section>
            <textarea style="width: 100%" v-model="hdagJson" class="editor-popup"></textarea>
          </q-card-section>
          <q-card-section>
            <q-btn label="Start" color="primary" @click="saveHdag" />
            <q-btn label="Cancel" color="primary" flat @click="showDialog = false" />
          </q-card-section>
        </q-card>
      </q-dialog>
      <q-dialog v-model="showDescriptorDialog">
        <q-card style="width: 800px; max-width: 800px">
          <q-card-section class="q-pa-md">
            <div class="text-h6">{{ descriptorTitle }}</div>
            <textarea style="width: 100%" v-model="descriptorContent" class="editor-popup"></textarea>
          </q-card-section>
          <q-card-actions align="right">
            <q-btn label="Save" color="primary" @click="saveDescriptor" />
            <q-btn flat label="Close" color="primary" v-close-popup />
          </q-card-actions>
        </q-card>
      </q-dialog>
      <q-dialog v-model="showEditIntentDialog">
        <q-card style="width: 800px; max-width: 800px">
          <q-card-section>
            <div class="text-h6">Edit Intent</div>
          </q-card-section>
          <q-card-section>
            <div style="
                display: flex;
                gap: 20px;
                align-items: center;
                padding-bottom: 50px;
                padding-left: 50px;
              ">
              <label><strong>Artifact Intent: </strong></label>
              <q-select style="width: 150px" v-model="editedIntent.hdaGraphIntent.type" :options="artifactIntentOptions"
                @update:model-value="updateServiceOptions" />
            </div>
            <strong style="padding-left: 50px; padding-bottom: 10px">Services (Deployment Intent):</strong>
            <div v-for="(service, sIndex) in editedIntent.services" :key="sIndex" class="q-mb-md"
              style="padding-top: 10px; border-top: 1px dashed #ccc">
              <div style="padding: 10px 0 10px 50px">
                <strong>{{ service.id }}</strong>
              </div>
              <div style="display: flex; gap: 20px; padding-left: 50px">

                <div>
                  <label>CPU:</label>
                  <q-select v-model="service.deployment.intent.compute.cpu" :options="cpuOptions" />
                </div>
                <div>
                  <label>RAM:</label>
                  <q-select v-model="service.deployment.intent.compute.ram" :options="ramOptions" />
                </div>
                <div>
                  <label>Storage:</label>
                  <q-select v-model="service.deployment.intent.compute.storage" :options="storageOptions" />
                </div>
                <div>
                  <label>GPU Enabled:</label>
                  <q-option-group color="primary" v-model="service.deployment.intent.compute.gpu.enabled"
                    :options="[{ label: '', value: true }]" type="toggle" inline
                    :disable="editedIntent.hdaGraphIntent.type !== 'custom'" />
                </div>
                <div v-if="shouldShowDeviceProximity(sIndex)">
                  <label>Device Proximity Enabled:</label>
                  <q-option-group color="primary" v-model="service.deployment.intent.network.deviceProximity.enabled"
                    :options="[{ label: '', value: true }]" type="toggle" inline
                    :disable="editedIntent.hdaGraphIntent.type !== 'custom'" />
                </div>
              </div>

              <div v-if="service.deployment.intent.network.latencies.length > 0"
                style="padding: 10px 0 0 50px; display: flex; gap: 20px; justify-content: flex-start; align-items: center;">
                <label>QoS per Connection Point:</label>
                <div v-for="(cp, cpIndex) in service.deployment.intent.network
                  .latencies" :key="cpIndex" style="display: flex; gap: 20px;  margin-top: 20px;">

                  <div style="width:100px">
                    <strong>{{ cp.connectionPoint }}</strong>
                    <q-select v-model="cp.qos" :options="qosOptions" style="min-width: 150px" />
                  </div>

                </div>
              </div>
            </div>
          </q-card-section>
          <q-card-actions align="right">
            <q-btn label="Save" color="primary" @click="saveIntent" />
            <q-btn flat label="Cancel" color="primary" @click="() => (showEditIntentDialog = false)" />
          </q-card-actions>
        </q-card>
      </q-dialog>
    </q-page>
    <router-view />
  </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { useRouter } from 'vue-router';
import { QPage, QCard, QCardSection, QDialog } from 'quasar';
import { useFetchArtifacts } from '../hooks/artifacts';
import { useFetchDescriptors } from '../hooks/descriptors';
import yaml from 'js-yaml';

const router = useRouter();
const { isLoading, error, artifacts, fetchArtifacts } = useFetchArtifacts();
const showDescriptorDialog = ref(false);
const descriptorTitle = ref('');
const descriptorContent = ref('');
const showDialog = ref(false);
const showEditIntentDialog = ref(false);
const editedIntent = ref(null);
onMounted(() => {
  fetchArtifacts('HDAG');
});
const cpuOptions = ref(['light', 'small', 'medium', 'large']);
const ramOptions = ref(['light', 'small', 'medium', 'large']);
const storageOptions = ref(['small', 'medium', 'large']);
const qosOptions = ref(['best-effort', 'low', 'ultralow']);
const artifactIntentOptions = [
  'default',
  'highAvailability',
  'highPerformance',
  'energyEfficiency',
  'custom',
];
const { descriptor, fetchDescriptor, publishHdag } = useFetchDescriptors();
const hdagJson = ref(
  JSON.stringify(
    {
      description: 'string',
      hdaGraphIntent: 'string',
      id: 'string',
      services: [
        {
          deploymentType: 'auto',
          intent: {
            affinity: 'string',
            consumption: 'LOW',
            location: 'FOLLOWUSER',
            sla: 'MMTC',
          },
          ref: 'string',
        },
      ],
    },
    null,
    2,
  ),
);
async function showDescriptor(id) {
  if (descriptorContent.value === '') {
    await fetchDescriptor(id);
    const selectedDescriptor = descriptor.value.find((desc) =>
      desc.fileName.endsWith('.yaml'),
    );
    if (selectedDescriptor) {
      descriptorTitle.value = selectedDescriptor.fileName;
      descriptorContent.value = selectedDescriptor.content;
      showDescriptorDialog.value = true;
    }
  } else {
    showDescriptorDialog.value = true;

  }
}
async function editIntent(artifact) {
  if (!artifact?.descriptor?.id) return;
  if (descriptorContent.value === '') {
    await fetchDescriptor(artifact.descriptor.id);
    const selectedDescriptor = descriptor.value.find((desc) =>
      desc.fileName.endsWith('.yaml'),
    );

    if (selectedDescriptor) {
      descriptorTitle.value = selectedDescriptor.fileName;
      descriptorContent.value = selectedDescriptor.content;
    }
  }

  if (!descriptorContent.value) return;
  const descJson = yaml.load(descriptorContent.value);
  const activeIntentType = getActiveIntentType(
    descJson.hdaGraph.hdaGraphIntent,
  );
  const servicesMapped = descJson.hdaGraph.services?.map((svc) => {
    const netIntent = svc.deployment?.intent?.network || {};
    const computeIntent = svc.deployment?.intent?.compute || {};
    let cpArray = netIntent.latencies || [];
    if (netIntent.latencies && netIntent.latencies.length > 0) {
      cpArray = netIntent.latencies.map((latency) => ({
        connectionPoint: latency.connectionPoint,
        qos: latency.qos || 'best-effort'
      }));
    }
    return {
      id: svc.id,
      deployment: {
        intent: {
          network: {
            deviceProximity: {
              enabled: netIntent.deviceProximity?.enabled ?? false,
            },
            latencies: cpArray,
          },
          compute: {
            cpu: computeIntent.cpu ?? 'small',
            ram: computeIntent.ram ?? 'small',
            storage: computeIntent.storage ?? 'small',
            gpu: {
              enabled: computeIntent.gpu?.enabled ?? false,
            },
          },
        },
      },
    };
  });
  editedIntent.value = {
    originalDescriptor: descriptorTitle.value,
    descriptorObject: descJson,
    hdaGraphIntent: {
      type: activeIntentType,
    },
    services: servicesMapped || [],
  };
  updateServiceOptions(activeIntentType);
  showEditIntentDialog.value = true;
}
function getActiveIntentType(hdaIntent) {
  if (!hdaIntent) return 'default';
  const keys = Object.keys(hdaIntent);
  const foundKey = keys.find((k) => hdaIntent[k]?.enabled === true);
  return foundKey || 'default';
}
function updateServiceOptions(selectedIntent) {
  const intentRules = {
    default: {
      cpu: ['medium'],
      ram: ['medium'],
      storage: ['medium'],
      gpu: false,
      qos: ['best-effort'],
      deviceProximity: true,
    },
    highAvailability: {
      cpu: ['light', 'small', 'medium', 'large'],
      ram: ['light', 'small', 'medium', 'large'],
      storage: ['small', 'medium', 'large'],
      gpu: false,
      qos: ['best-effort', 'low', 'ultralow'],
      deviceProximity: null,
    },
    highPerformance: {
      cpu: ['medium', 'large'],
      ram: ['medium', 'large'],
      storage: ['large'],
      gpu: true,
      qos: ['low', 'ultralow'],
      deviceProximity: true,
    },
    energyEfficiency: {
      cpu: ['light', 'small', 'medium'],
      ram: ['light', 'small', 'medium'],
      storage: ['small', 'medium'],
      gpu: false,
      qos: ['best-effort', 'low'],
      deviceProximity: false,
    },
    custom: {
      cpu: ['light', 'small', 'medium', 'large'],
      ram: ['light', 'small', 'medium', 'large'],
      storage: ['small', 'medium', 'large'],
      gpu: null,
      qos: ['best-effort', 'low', 'ultralow'],
      deviceProximity: null,
    },
  };
  const rule = intentRules[selectedIntent] || intentRules.default;

  cpuOptions.value.splice(0, cpuOptions.value.length, ...rule.cpu);
  ramOptions.value.splice(0, ramOptions.value.length, ...rule.ram);
  storageOptions.value.splice(0, storageOptions.value.length, ...rule.storage);
  qosOptions.value.splice(0, qosOptions.value.length, ...rule.qos);

  editedIntent.value?.services?.forEach((service, idx) => {
    // For string selects, if the current value is not allowed, default it to the first option.
    if (!rule.cpu.includes(service.deployment.intent.compute.cpu)) {
      service.deployment.intent.compute.cpu = rule.cpu[0];
    }
    if (!rule.ram.includes(service.deployment.intent.compute.ram)) {
      service.deployment.intent.compute.ram = rule.ram[0];
    }
    if (!rule.storage.includes(service.deployment.intent.compute.storage)) {
      service.deployment.intent.compute.storage = rule.storage[0];
    }
    if (
      service.deployment.intent.network.latencies?.length > 0 &&
      !rule.qos.includes(service.deployment.intent.network.latencies[0].qos)
    ) {
      service.deployment.intent.network.latencies[0].qos = rule.qos[0];
    }

    // For booleans, only force update if the rule is defined.
    if (rule.gpu !== null) {
      service.deployment.intent.compute.gpu.enabled = rule.gpu;
    }
    if (rule.deviceProximity !== null) {
      // For deviceProximity, if enabled by rule, only the first service is true.
      if (rule.deviceProximity === true) {
        service.deployment.intent.network.deviceProximity.enabled = (idx === 0);
      } else {
        service.deployment.intent.network.deviceProximity.enabled = false;
      }
    }
  });
}
function shouldShowDeviceProximity(sIndex) {
  const intent = editedIntent.value?.hdaGraphIntent?.type;
  if (!intent) return false;
  if (intent === 'energyEfficiency') {
    return false;
  }
  return sIndex === 0;
}
async function saveIntent() {
  const descJson = editedIntent.value.descriptorObject;
  const chosen = editedIntent.value.hdaGraphIntent.type;
  Object.keys(descJson.hdaGraph.hdaGraphIntent || {}).forEach((k) => {
    descJson.hdaGraph.hdaGraphIntent[k].enabled = k === chosen;
  });
  editedIntent.value.services.forEach((svc) => {
    const target = descJson.hdaGraph.services.find((d) => d.id === svc.id);
    if (!target) return;
    target.deployment.intent.compute.cpu = svc.deployment.intent.compute.cpu;
    target.deployment.intent.compute.ram = svc.deployment.intent.compute.ram;
    target.deployment.intent.compute.storage =
      svc.deployment.intent.compute.storage;
    target.deployment.intent.compute.gpu.enabled =
      svc.deployment.intent.compute.gpu.enabled;
    target.deployment.intent.network.deviceProximity.enabled =
      svc.deployment.intent.network.deviceProximity.enabled;
    target.deployment.intent.network.latencies =
      svc.deployment.intent.network.latencies.map((cpObj) => {
        return cpObj;
      });
  });
  const updatedYaml = yaml.dump(descJson);
  descriptorContent.value = updatedYaml;
  showEditIntentDialog.value = false;
}
async function publishDescriptor() {
  await publishHdag(descriptorContent.value);
  showDescriptorDialog.value = false;
}
function saveDescriptor() {
  showDescriptorDialog.value = false;
}
function saveHdag() {
  publishHdag(hdagJson.value);
  showDialog.value = false;
}
function viewGraph(artifactName) {
  router.push(`application_graph/${artifactName}`);
}
</script>

<style scoped>
.application-graphs .q-card {
  width: 100%;
  max-width: 300px;
}

.text-h6 {
  width: 100%;
}

.application-graphs ul {
  padding-left: 20px;
}

.card-header {
  display: flex;
  justify-content: space-between;
}

.card-header-actions {
  display: flex;
}

.editor-popup {
  width: 500px;
  height: 500px;
}
</style>
